stock wS_StartGame(player1,	player2)
{
	g_Partner[player1]		= player2;
	g_Partner[player2]		= player1;

	g_bWaitPartner[player1]	= false;
	g_bWaitPartner[player2]	= false;

	wS_ClearTimer(g_hTimer[player1]);
	wS_ClearTimer(g_hTimer[player2]);

	// Кто первый ходит
	if (GetRandomInt(0, 1)	< 1)
	{
		new x				= player1;
		player1				= player2;
		player2				= x;
	}

	g_Charr[player1]		= 'X';
	g_Charr[player2]		= 'O';
	g_Field[player1]		= 1;
	g_Field[player2]		= 0;
	g_CharrList[player1]	= {'#', '#', '#', '#', '#', '#', '#', '#', '#', '#'};
	g_CharrList[player2]	= {'#', '#', '#', '#', '#', '#', '#', '#', '#', '#'};

	g_MySec[player1]		= g_Sec;
	g_hTimer[player1]		= CreateTimer(1.0, g_hTimer_CallBack, player1, TIMER_REPEAT);
	wS_GamePanel(player1);
}

static wS_GamePanel(client)
{
	new partner				= g_Partner[client];
	if (g_Partner[partner]	!= client)
	{
		wS_ClearTimer(g_hTimer[client]);
		g_Partner[client]	= 0;
		return;
	}

	new Handle:panel		= CreatePanel();
	decl x, String:text[250];

	// partner
	Format(text, 250, "Соперник: %N\nХод: ЕГО [%d]\n \n", client, g_MySec[client]);
	SetPanelTitle(panel, text);
	for (x = 1; x < 10; x++)
	{
		if (x < 2) Format(text, 250, "%c           ", g_CharrList[client][x]);
		else if (x == 3 || x == 6 || x == 9) Format(text, 250, "%s%c\n \n", text, g_CharrList[client][x]);
		else Format(text, 250, "%s%c           ", text, g_CharrList[client][x]);
	}
	DrawPanelText(panel, text);
	SendPanelToClient(panel, partner, GamePanel_CallBack, 1);
	CloseHandle(panel);

	// client
	panel = CreatePanel();
	Format(text, 250, "Соперник: %N\nХод: ВАШ [%d]\n \n", partner, g_MySec[client]);
	SetPanelTitle(panel, text);
	for (x = 1; x < 10; x++)
	{
		if (x < 2) Format(text, 250, "%c           ", x == g_Field[client] ? g_Charr[client] : g_CharrList[client][x]);
		else if (x == 3 || x == 6 || x == 9) Format(text, 250, "%s%c\n \n", text, x == g_Field[client] ? g_Charr[client] : g_CharrList[client][x]);
		else Format(text, 250, "%s%c           ", text, x == g_Field[client] ? g_Charr[client] : g_CharrList[client][x]);
	}
	DrawPanelText(panel, text);
	DrawPanelItem(panel, "->");
	DrawPanelItem(panel, "Сделать ход");
	SendPanelToClient(panel, client, GamePanel_CallBack, 0);
	CloseHandle(panel);
}

public GamePanel_CallBack(Handle:panel, MenuAction:action, client, item)
{
	if (action != MenuAction_Select || item > 2)
		return;

	if (item == 1)
	{
		wS_Field(client);
		wS_GamePanel(client);
	}
	else if (item == 2)
	{
		wS_ClearTimer(g_hTimer[client]);

		new partner = g_Partner[client];
		if (g_Partner[partner] != client)
		{
			g_Partner[client] = 0;
			return;
		}

		wS_ClearTimer(g_hTimer[partner]);

		g_CharrList[client] [g_Field[client]] = g_Charr[client];
		g_CharrList[partner][g_Field[client]] = g_Charr[client];

		if (g_Field[client] == 1)
		{
			if ((g_CharrList[client][2] == g_Charr[client] && g_CharrList[client][3] == g_Charr[client])
				|| (g_CharrList[client][4] == g_Charr[client] && g_CharrList[client][7] == g_Charr[client])
				|| (g_CharrList[client][5] == g_Charr[client] && g_CharrList[client][9] == g_Charr[client]))
			{
				wS_Win(client, partner);
				return;
			}
		}
		else if (g_Field[client] == 2)
		{
			if ((g_CharrList[client][1] == g_Charr[client] && g_CharrList[client][3] == g_Charr[client])
				|| (g_CharrList[client][5] == g_Charr[client] && g_CharrList[client][8] == g_Charr[client]))
			{
				wS_Win(client, partner);
				return;
			}
		}
		else if (g_Field[client] == 3)
		{
			if ((g_CharrList[client][1] == g_Charr[client] && g_CharrList[client][2] == g_Charr[client])
				|| (g_CharrList[client][5] == g_Charr[client] && g_CharrList[client][7] == g_Charr[client])
				|| (g_CharrList[client][6] == g_Charr[client] && g_CharrList[client][9] == g_Charr[client]))
			{
				wS_Win(client, partner);
				return;
			}
		}
		else if (g_Field[client] == 4)
		{
			if ((g_CharrList[client][1] == g_Charr[client] && g_CharrList[client][7] == g_Charr[client])
				|| (g_CharrList[client][5] == g_Charr[client] && g_CharrList[client][6] == g_Charr[client]))
			{
				wS_Win(client, partner);
				return;
			}
		}
		else if (g_Field[client] == 5)
		{
			if ((g_CharrList[client][2] == g_Charr[client] && g_CharrList[client][8] == g_Charr[client])
				|| (g_CharrList[client][4] == g_Charr[client] && g_CharrList[client][6] == g_Charr[client])
				|| (g_CharrList[client][1] == g_Charr[client] && g_CharrList[client][9] == g_Charr[client])
				|| (g_CharrList[client][3] == g_Charr[client] && g_CharrList[client][7] == g_Charr[client]))
			{
				wS_Win(client, partner);
				return;
			}
		}
		else if (g_Field[client] == 6)
		{
			if ((g_CharrList[client][3] == g_Charr[client] && g_CharrList[client][9] == g_Charr[client])
				|| (g_CharrList[client][5] == g_Charr[client] && g_CharrList[client][4] == g_Charr[client]))
			{
				wS_Win(client, partner);
				return;
			}
		}
		else if (g_Field[client] == 7)
		{
			if ((g_CharrList[client][4] == g_Charr[client] && g_CharrList[client][1] == g_Charr[client])
				|| (g_CharrList[client][8] == g_Charr[client] && g_CharrList[client][9] == g_Charr[client])
				|| (g_CharrList[client][5] == g_Charr[client] && g_CharrList[client][3] == g_Charr[client]))
			{
				wS_Win(client, partner);
				return;
			}
		}
		else if (g_Field[client] == 8)
		{
			if ((g_CharrList[client][7] == g_Charr[client] && g_CharrList[client][9] == g_Charr[client])
				|| (g_CharrList[client][5] == g_Charr[client] && g_CharrList[client][2] == g_Charr[client]))
			{
				wS_Win(client, partner);
				return;
			}
		}
		else if (g_Field[client] == 9)
		{
			if ((g_CharrList[client][8] == g_Charr[client] && g_CharrList[client][7] == g_Charr[client])
				|| (g_CharrList[client][6] == g_Charr[client] && g_CharrList[client][3] == g_Charr[client])
				|| (g_CharrList[client][5] == g_Charr[client] && g_CharrList[client][1] == g_Charr[client]))
			{
				wS_Win(client, partner);
				return;
			}
		}

		if (wS_FieldsFilled(client))
		{
			wS_Win(client, partner, false);
			return;
		}

		wS_Field(partner);
		wS_GamePanel(partner);
		g_MySec[partner]  = g_Sec;
		g_hTimer[partner] = CreateTimer(1.0, g_hTimer_CallBack, partner, TIMER_REPEAT);
	}
}

static wS_Win(client, partner, bool:win = true)
{
	g_Partner[client]	= 0;
	g_Partner[partner]	= 0;

	new Handle:panel	= CreatePanel();
	decl String:text[250];
	if (win) Format(text, 250, "Победитель: %N\n \n", client);
	else strcopy(text, 250, "НИЧЬЯ\n \n");
	SetPanelTitle(panel, text);

	for (new x = 1; x < 10; x++)
	{
		if (x < 2) Format(text, 250, "%c           ", g_CharrList[client][x]);
		else if (x == 3 || x == 6 || x == 9) Format(text, 250, "%s%c\n \n", text, g_CharrList[client][x]);
		else Format(text, 250, "%s%c           ", text, g_CharrList[client][x]);
	}

	DrawPanelText(panel, text);
	SendPanelToClient(panel, client,  GamePanel_CallBack, 10);
	SendPanelToClient(panel, partner, GamePanel_CallBack, 10);
	CloseHandle(panel);
}

public Action:g_hTimer_CallBack(Handle:timer, any:client)
{
	if (--g_MySec[client]	< 1)
	{
		wS_Info(client,		"Время истекло, вы проиграли!");
		new partner			= g_Partner[client];
		wS_Info(partner,	"Время истекло, вы победили!");
		g_hTimer[client]	= INVALID_HANDLE;
		wS_ClearTimer(g_hTimer[partner]);
		g_Partner[client]	= 0;
		g_Partner[partner]	= 0;
		return Plugin_Stop;
	}
	wS_GamePanel(client);
	return Plugin_Continue;
}